<?php

namespace Teknisa\FIN\Modules\ContaPagar\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\FIN\Modules\ContaPagar\Factory\Pag20000ControleRateioContasPagarFactory;

/**
 * Class 
 * @package Teknisa\FIN\Modules\ContaPagar\Services
 */
class  Pag20000ControleRateioContasPagarService{

    protected $entityManager;
    protected $environment;
    protected $pag20000controlerateiocontaspagarfactory;
    

    public function __construct(EntityManager $entityManager, Environment $environment, Pag20000ControleRateioContasPagarFactory $pag20000controlerateiocontaspagarfactory)
    {
        $this->entityManager             = $entityManager;
        $this->environment               = $environment;
        $this->Pag20000ControleRateioContasPagarFactory      = $pag20000controlerateiocontaspagarfactory;
    }
    
    
    public function salvarRateio($row){
        try {
                $nrorg = $this->environment->getNrOrgTrab();
                foreach($row as $dados){
                    if($dados["__is_new"] === true){
                        $cdcliente    = $dados['CDCLIENTE'];
                        $nrlanctonf   = $dados['NRLANCTONF'];
                        $cdfilial     = $dados['CDFILIAL'];
                        $nrseqvenpag  = $dados['NRSEQVENPAG'];
                        $nrparcelapag = $dados['NRPARCELAPAG'];
                        $cdfiratctpag = $dados['CDFIRATCTPAG'];
                        $vrratccctpag = $dados['VRRATCCCTPAG'];
                        
                        // Insere Rateio
                        $inserirRateio = $this->Pag20000ControleRateioContasPagarFactory->insereRateio(
                            $nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $cdcliente, $cdfiratctpag, $vrratccctpag
                        );
                    }
                
                }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function updateRateio($row){
        try{
                $nrorg = $this->environment->getNrOrgTrab();
                $cdcliente    = $row[0]['CDCLIENTE'];
                $nrlanctonf   = $row[1]['NRLANCTONF'];
                $cdfilial     = $row[2]['CDFILIAL'];
                $nrseqvenpag  = $row[3]['NRSEQVENPAG'];
                $nrparcelapag = $row[4]['NRPARCELAPAG'];
                $cdfiratctpag = $row[5]['CDFIRATCTPAG'];
                $vrratccctpag = $row[6]['VRRATCCCTPAG'];
                
            $atualizaRateio = $this->Pag20000ControleRateioContasPagarFactory->updateRateio(
                $nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $cdcliente, $cdfiratctpag, $vrratccctpag
            );
        }catch(\Exception $e){
            throw $e;
        }
    }
   
    public function deleteRateio($rowDeletado, $rowData){
        try{

                $nrorg = $this->environment->getNrOrgTrab();
                $cdcliente    = $rowDeletado[0]['CDCLIENTE'];
                $nrlanctonf   = $rowDeletado[1]['NRLANCTONF'];
                $cdfilial     = $rowDeletado[2]['CDFILIAL'];
                $nrseqvenpag  = $rowDeletado[3]['NRSEQVENPAG'];
                $nrparcelapag = $rowDeletado[4]['NRPARCELAPAG'];
                $cdfiratctpag = $rowDeletado[5]['CDFIRATCTPAG'];
                $vrratccctpag = $rowDeletado[6]['VRRATCCCTPAG'];
                
            $atualizaRateio = $this->Pag20000ControleRateioContasPagarFactory->deleteRateio(
                $nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $cdcliente, $cdfiratctpag, $vrratccctpag
            );
            
            //Verifica se o data do grid tem dados de rateio adicionados
            $indiceAtualizar = 0;
            if(count($rowData) > 1){
                
                //procura o indice do array que não foi deletado para passar o o valor da linha de cima para 100%
                foreach ($rowData as $indice => $subarray) {
                    if (isset($subarray["CDCLIENTE"]) && $subarray["CDCLIENTE"] !== $rowDeletado[0]['CDCLIENTE']) {
                        $indiceAtualizar = $indice;
                    }
                }
                
                $nrorg = $this->environment->getNrOrgTrab();
                $cdclienteAt    = $rowData[$indiceAtualizar ]['CDCLIENTE'];
                $nrlanctonfAt   = $rowData[$indiceAtualizar ]['NRLANCTONF'];
                $cdfilialAt     = $rowData[$indiceAtualizar ]['CDFILIAL'];
                $nrseqvenpagAt  = $rowData[$indiceAtualizar ]['NRSEQVENPAG'];
                $nrparcelapagAt = $rowData[$indiceAtualizar ]['NRPARCELAPAG'];
                $cdfiratctpagAt = $rowData[$indiceAtualizar ]['CDFIRATCTPAG'];
                
                //Soma o valor deletado com o valor do indice que ficou para não deixar rateio menor do que 100%
                $vrratccctpagAt = $vrratccctpag + floatval($rowData[$indiceAtualizar]['VRRATCCCTPAG']);
                // atualiza
                $atualizaRateio = $this->Pag20000ControleRateioContasPagarFactory->updateRateio(
                $nrorg, $cdfilialAt, $nrlanctonfAt, $nrseqvenpagAt, $nrparcelapagAt, $cdclienteAt, $cdfiratctpagAt, $vrratccctpagAt
            );
            }
        }catch(\Exception $e){
            throw $e;
        }
    }

}