<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Teknisa\FIN\Modules\ContaReceber\Services\EnvioAutomaticoService;
use Zeedhi\Framework\Remote\cURLRequest;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

/**
 * Class EnvioAutomaticoController
 * @package Teknisa\FIN\Modules\ContaReceber\Controllers
 */
class EnvioAutomaticoController{
    
    protected $crudService;
    protected $parameterBag;
    protected $environment;
    protected $envioAutomaticoService;
    protected $connectionCustom;
    
    /**
     * @param CrudService            $crudService
     * @param ParameterBag           $parameterBag
     * @param Environment            $environment
     * @param EnvioAutomaticoService $envioAutomaticoService
     */
    public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, EnvioAutomaticoService $envioAutomaticoService,  $connectionCustom){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->envioAutomaticoService = $envioAutomaticoService;
        $this->connectionCustom = $connectionCustom;
    }

    /**
     * Envio Automático de Título por E-mail
     */
    public function envioAutomaticoTituloPorEmail($request, $response){
        try {
            $row  = $request->getParameters();
            
            $nrorg = $row['NRORG']; 

            //Seta atributos NRORG que sera usado no Jenkins
            $_SESSION['_sf2_attributes']['NRORG'] = $row['NRORG'];
            $_SESSION['_sf2_attributes']['ORGANIZATION_ID'] = $row['NRORG'];
            
            //Paramentos necessários para conexão com o banco de dados, para o jenkins não perder a conexão
            $newEntityManager = null;
            $useVpd = InstanceManager::getInstance()->getService('EntityManager')->getConnection()->getParams()['useVpd'];
            
            // Envio Automático de Título por E-mail
            $this->envioAutomaticoService->envioAutomaticoTituloPorEmail($nrorg,$useVpd,$newEntityManager, $request, $response);
            
        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }

    /**
     * Envio Automático de Carta de Cobrança por E-mail
     */
    public function envioAutomaticoCartaCobrancaPorEmail($request, $response){
        try {
            $row  = $request->getParameters();
            
            $nrorg = $row['NRORG']; 
            
            //Seta atributos NRORG que sera usado no Jenkins
            $_SESSION['_sf2_attributes']['NRORG'] = $row['NRORG'];
            $_SESSION['_sf2_attributes']['ORGANIZATION_ID'] = $row['NRORG'];
            
            $newEntityManager = null;
            $useVpd = InstanceManager::getInstance()->getService('EntityManager')->getConnection()->getParams()['useVpd'];
            
            // Envio Automático de Carta de Cobrança por E-mail
            $this->envioAutomaticoService->envioAutomaticoCartaCobrancaPorEmail($nrorg,$useVpd, $newEntityManager, $request, $response);
        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }
    
}