<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Controllers;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Services\Bco57000RecalculoOrcamentoCentroCustoService;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Exception;


class Bco57000RecalculoOrcamentoCentroCustoController extends TeknisaCrud {

    protected $dataSourceName, $masks, $service;

    public function __construct($crudService, $parameterBag, Bco57000RecalculoOrcamentoCentroCustoService $bco57000RecalculoOrcamentoCentroCustoService) {
        $this->bco57000RecalculoOrcamentoCentroCustoService = $bco57000RecalculoOrcamentoCentroCustoService;
        //parent::__construct($crudService, $parameterBag);
    }

    public function recalcularOrcamentoCentroCusto(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $row = $data[0];
            $centroCusto = $data[1];
            $this->bco57000RecalculoOrcamentoCentroCustoService->recalcularOrcamentoCentroCusto($centroCusto, $row);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function saveOrcamentoCentroCusto(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $row = $data[0];
            $orcamentos = $data[1];
            $this->bco57000RecalculoOrcamentoCentroCustoService->saveOrcamentoCentroCusto($orcamentos, $row);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function cadastramentoAutomaticoCentCust(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $opcao = $data[0];
            $origem = $data[1];
            $destino = $data[2];
            $this->bco57000RecalculoOrcamentoCentroCustoService->CadastramentoAutomaticoDoOrcamento($opcao, $origem, $destino);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}
