<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIN\Controllers\TeknisaCrud;

class MovbancarioExtratoController extends TeknisaCrud{

    protected $dataSourceName = 'movbancario_extrato';

	public function __construct($crudService, $parameterBag) {
		parent::__construct($crudService, $parameterBag);
	}
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        parent::find($request, $response);
        $dataSets = $response->getDataSets();
        
        if(!empty($dataSets)){
            if(isset($dataSets[0])){
                $rows = $dataSets[0]->getRows();
                
                if(isset($rows[0])){
                    $saldo = $rows[0]['SALDOINIC'];
                    
                    for($i = 0; count($rows) > $i; $i++){
                        if($rows[$i]['IDMOVBANC'] != 'X'){
                             $saldo += $rows[$i]['VRMOVBANCSIMB'];
                        }
                        else {
                            $saldo  = $rows[$i]['VRMOVBANCSIMB'];
                        }
                       
                        $rows[$i]['SALDO'] = $saldo;
                    }
                }
                
                $newDataSet = new DataSet($this->dataSourceName, $rows);
                $response->setDataSets(array($newDataSet));
            }else $response->setDataSets(array($dataSets));
        }
    }
    
}