<?php

namespace Teknisa\FIN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\FIN\Factories\Rec01400RelatorioCustomizavelCurvaAbcClientesFactory;

class Rec01400RelatorioCustomizavelCurvaAbcClientesService {


    protected $entityManager;
    protected $rec01400RelatorioCustomizavelCurvaAbcClientesFactory;

    function __construct(EntityManager $entityManager, Rec01400RelatorioCustomizavelCurvaAbcClientesFactory $rec01400RelatorioCustomizavelCurvaAbcClientesFactory){
        $this->entityManager          = $entityManager;
        $this->rec01400RelatorioCustomizavelCurvaAbcClientesFactory = $rec01400RelatorioCustomizavelCurvaAbcClientesFactory;
    }
    
    function executaProcedureCurvaAbcsClientesService($parametro) {
      try {

        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();

        $cdEmpresa = '';
        $cdCliente = '';
        $cdTipoConta = '';
        $cdStatus = '';
        $dtIniBaixa = '';
        $dtFimBaixa = '';
        $tdCurvaGeral = '';
        // Verifica caso os parametros estejam vazios, sempre seja passado para a procedure "T" - Todos
        if (array_key_exists('value', $parametro[0]) && !empty($parametro[0]["value"])){
          $cdEmpresa = implode(",", $parametro[0]["value"]);
        } else {
          $cdEmpresa = 'T';
        }
        
        if (array_key_exists('value', $parametro[1]) && !empty($parametro[1]["value"])){
          $cdCliente = implode(",", $parametro[1]["value"]);
        } else {
          $cdCliente = 'T';
        }
        
        if (array_key_exists('value', $parametro[2]) && !empty($parametro[2]["value"])){
          $cdTipoConta = implode(",", $parametro[2]["value"]);
        } else {
          $cdTipoConta = 'T';
        }
        
        if (array_key_exists('value', $parametro[3]) && !empty($parametro[3]["value"])){
         $cdStatus = implode(",", $parametro[3]["value"]);
        } else {
          $cdStatus = 'T';
        }
        
        if (array_key_exists('value', $parametro[6]) && !empty($parametro[6]["value"])){
          $dtIniBaixa = $parametro[6]["value"];
        } else {
          $dtIniBaixa = '';
        }
        
        if (array_key_exists('value', $parametro[7]) && !empty($parametro[7]["value"])){
         $dtFimBaixa = $parametro[7]["value"];
        } else {
          $dtFimBaixa = '';
        }
        
        $vencInicio = $parametro[4]["value"];
        $vencFim = $parametro[5]["value"];
        
        if ($dtIniBaixa === '' && $dtFimBaixa === '') {
          $tdCurvaGeral = 'T';
        } else {
          $tdCurvaGeral = '';
        }
        
        $idCurva = $parametro[9]["value"];
        
        $nrSeqCurvaAbcCli =  $this->rec01400RelatorioCustomizavelCurvaAbcClientesFactory->executaProcedureCurvaAbcsClientesFactory($cdEmpresa, $cdCliente, $cdTipoConta, $cdStatus, $vencInicio,$vencFim,$dtIniBaixa,$dtFimBaixa, $tdCurvaGeral, $idCurva);
        $dadosCurva = $this->rec01400RelatorioCustomizavelCurvaAbcClientesFactory->buscaDadosRelatorio($nrSeqCurvaAbcCli);
        return $nrSeqCurvaAbcCli;
        
      }catch(\Exception $e) {
        return ($e->getMessage());
      }
    }
    
    function buscaDadosRElatorio(){
       $dados = $this->rec01400RelatorioCustomizavelCurvaAbcClientesFactory->buscaDadosRelatorio();
       return $dados;
    }
}