<?php
/**
 * GepLogalterasoliLogic.
 *
 * @package Logic
 * @author  erikasouza
 */
Class GepLogalterasoliLogic{


    private $_GepLogalterasoliEntity;
    private $_GepSolicitacaoEntity;


    /**
     * Construtor da classe.
     */
    public function __construct(){
        $this->_GepLogalterasoliEntity = new GepLogalterasoliEntity();
        $this->_GepSolicitacaoEntity   = new GepSolicitacaoEntity();
    }


    /**  ok
     * Gera parte do log (before) da solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da Solicitacao.
     *
     * @return boolean
     */
    public function geraLogBeforeSolicitacao($nrorg, $solicitacao) {
        if (empty($solicitacao) === true) {
            $arr_fields['BEFORE'] = null;
        } else {
            $dados_ant_soli = $this->_GepSolicitacaoEntity->retornaDadosSolicitacao($nrorg, $solicitacao);
            $arr_fields['BEFORE'] = $dados_ant_soli->getDao()->toArray();
        }

        return $arr_fields;
    }


    /**  ok
     * Gera parte do log (after) da solicitacao, uni a anterior (before) e insere no banco.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da Solicitacao.
     *
     * @return boolean
     */
    public function geraLogAfterSolicitacao($nrorg, $solicitacao, $operador, $data, $log_before) {
        $dados_atual_soli = $this->_GepSolicitacaoEntity->retornaDadosSolicitacao($nrorg, $solicitacao);
        $log_before['AFTER'] = $dados_atual_soli->getDao()->toArray();

        $log_final = json_encode($log_before);

        $codigo = self::novoCodigoGepLogalterasoli($nrorg);
        $insere_log = $this->_GepLogalterasoliEntity->insereLogSolicitacao(
                $codigo, $solicitacao, $log_final, $operador, $data, $nrorg
        );

        return true;
    }


    /**    ok
     * Gera novo codigo para o log da solicitacao.
     *
     * @param integer $nrorg Numero da organizacao.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepLogalterasoli($nrorg){
        $codigo = GepLogalterasoliEntity::novoCodigoGepLogalterasoli($nrorg);
        return $codigo;
    }

    public static function entityToArray($obj) {
        $return = array();

        $arr = (array)$obj;
        foreach ($arr as $k => $v) {
            if (!is_array($v) && !is_object($v)) {
                $return[$k] = $v;
            }
        }

        return $return;
    }

}