/*
  Tabela REQUESTO:
         Requisies de Estoque
  Descrio :
      Insere registros na tabela LOGOPERA a partir de alteraes na tabela REQUESTO
  Objetivo  :
      Gerar um log que vai registrar as alteraes na tabela REQUESTO utilizando a
      tabela Geral de Logs de Operaes
@C:\WEB_411\Sql\End_Conv\Oracle\02FU_ESTTRGS_LOG_EST_ITREQUESTO
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_EST_ITREQUESTO' AND
                 TYPE   = 'TR' 		         AND
	              U.UID  = O.UID              AND
	              U.NAME = USER)
DROP TRIGGER LOG_EST_ITREQUESTO
GO


CREATE TRIGGER LOG_EST_ITREQUESTO
ON ITREQUESTO
FOR INSERT, UPDATE, DELETE
AS

  DECLARE @V_USUARIO          VARCHAR(40);
  DECLARE @V_TIPO             VARCHAR(1);
  DECLARE @V_ITPESQ           VARCHAR(50);
  DECLARE @V_DESC             VARCHAR(300);
  DECLARE @V_CDFILLOGOPER     VARCHAR(4);
  DECLARE @V_DTOPER           DATETIME;
  DECLARE @V_DSREMOTEADDR     VARCHAR(15);
  DECLARE @V_DSREMOTEHOST     VARCHAR(15);
  DECLARE @V_DSSERVERRDM      VARCHAR(20);
  DECLARE @V_DSSERVMETHOD     VARCHAR(30);
  DECLARE @V_DSREMOTEOPER     VARCHAR(12);

  DECLARE @V_OLD_CDFILIAL     VARCHAR(04);
  DECLARE @V_OLD_NRREQUESTO   VARCHAR(10);
  DECLARE @V_OLD_CDPRODUTO    VARCHAR(10);
  DECLARE @V_OLD_QTREQUESTO   NUMERIC(15,5);
  DECLARE @V_OLD_QTDEVOREQU   NUMERIC(15,5);
  DECLARE @V_OLD_IDSTITREQU   VARCHAR(02);
  DECLARE @V_OLD_CDFILILANC   VARCHAR(04);
  DECLARE @V_OLD_NRLANCESTQ   VARCHAR(10);
  DECLARE @V_OLD_NRSEQUITEM   VARCHAR(10);
  DECLARE @V_OLD_NRLOTEESTQ   VARCHAR(10);
  DECLARE @V_OLD_NRSUBLOTE    VARCHAR(50);
  DECLARE @V_OLD_DSREQUIAPROV VARCHAR(100);

  DECLARE @V_NEW_CDFILIAL     VARCHAR(04);
  DECLARE @V_NEW_NRREQUESTO   VARCHAR(10);
  DECLARE @V_NEW_CDPRODUTO    VARCHAR(10);
  DECLARE @V_NEW_QTREQUESTO   NUMERIC(15,5);
  DECLARE @V_NEW_QTDEVOREQU   NUMERIC(15,5);
  DECLARE @V_NEW_IDSTITREQU   VARCHAR(02);
  DECLARE @V_NEW_CDFILILANC   VARCHAR(04);
  DECLARE @V_NEW_NRLANCESTQ   VARCHAR(10);
  DECLARE @V_NEW_NRSEQUITEM   VARCHAR(10);
  DECLARE @V_NEW_NRLOTEESTQ   VARCHAR(10);
  DECLARE @V_NEW_NRSUBLOTE    VARCHAR(50);
  DECLARE @V_NEW_DSREQUIAPROV VARCHAR(100);
  DECLARE @V_IDCOMANDO        VARCHAR(2);

BEGIN
   SET @V_TIPO = '0';
   SET @V_CDFILLOGOPER = '';
   SET @V_DESC = ' '; 

   DECLARE C_CURSOR_ITREQ CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL,
         CDFILIAL  ,
         NRREQUESTO ,
         CDPRODUTO,
         QTREQUESTO,
         QTDEVOREQU,
         IDSTITREQU,
         CDFILILANC,
         NRLANCESTQ,
         NRSEQUITEM,
         NRLOTEESTQ,
         NRSUBLOTE,
         DSREQUIAPROV
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL  ,
         INSERTED.NRREQUESTO ,
         INSERTED.CDPRODUTO,
         INSERTED.QTREQUESTO,
         INSERTED.QTDEVOREQU,
         INSERTED.IDSTITREQU,
         INSERTED.CDFILILANC,
         INSERTED.NRLANCESTQ,
         INSERTED.NRSEQUITEM,
         INSERTED.NRLOTEESTQ,
         INSERTED.NRSUBLOTE,
         INSERTED.DSREQUIAPROV,
         DELETED.CDFILIAL  ,
         DELETED.NRREQUESTO ,
         DELETED.CDPRODUTO,
         DELETED.QTREQUESTO,
         DELETED.QTDEVOREQU,
         DELETED.IDSTITREQU,
         DELETED.CDFILILANC,
         DELETED.NRLANCESTQ,
         DELETED.NRSEQUITEM,
         DELETED.NRLOTEESTQ,
         DELETED.NRSUBLOTE,
         DELETED.DSREQUIAPROV
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL    = DELETED.CDFILIAL    AND
         INSERTED.NRREQUESTO  = DELETED.NRREQUESTO  AND
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIAL  ,
         INSERTED.NRREQUESTO ,
         INSERTED.CDPRODUTO,
         INSERTED.QTREQUESTO,
         INSERTED.QTDEVOREQU,
         INSERTED.IDSTITREQU,
         INSERTED.CDFILILANC,
         INSERTED.NRLANCESTQ,
         INSERTED.NRSEQUITEM,
         INSERTED.NRLOTEESTQ,
         INSERTED.NRSUBLOTE,
         INSERTED.DSREQUIAPROV,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_ITREQ;
   FETCH NEXT FROM C_CURSOR_ITREQ INTO @V_IDCOMANDO,
                                   @V_NEW_CDFILIAL,
                                   @V_NEW_NRREQUESTO,
                                   @V_NEW_CDPRODUTO,
                                   @V_NEW_QTREQUESTO,
                                   @V_NEW_QTDEVOREQU,
                                   @V_NEW_IDSTITREQU,
                                   @V_NEW_CDFILILANC,
                                   @V_NEW_NRLANCESTQ,
                                   @V_NEW_NRSEQUITEM,
                                   @V_NEW_NRLOTEESTQ,
                                   @V_NEW_NRSUBLOTE,
                                   @V_NEW_DSREQUIAPROV,
                                   @V_OLD_CDFILIAL,
                                   @V_OLD_NRREQUESTO,
                                   @V_OLD_CDPRODUTO,
                                   @V_OLD_QTREQUESTO,
                                   @V_OLD_QTDEVOREQU ,
                                   @V_OLD_IDSTITREQU,
                                   @V_OLD_CDFILILANC,
                                   @V_OLD_NRLANCESTQ,
                                   @V_OLD_NRSEQUITEM,
                                   @V_OLD_NRLOTEESTQ,
                                   @V_OLD_NRSUBLOTE,
                                   @V_OLD_DSREQUIAPROV;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_IDCOMANDO = 'D') BEGIN

         SET @V_DESC = @V_DESC + 'Filial='        + @V_OLD_CDFILIAL;
         SET @V_DESC = @V_DESC + ' NrRequesicao=' + @V_OLD_NRREQUESTO;
         SET @V_DESC = @V_DESC + ' Produto='      + @V_OLD_CDPRODUTO;

         IF @V_OLD_QTREQUESTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Qtde Req='     + CONVERT(VARCHAR,@V_OLD_QTREQUESTO);
         END;

         IF @V_OLD_QTDEVOREQU IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Qtde Dev='     + CONVERT(VARCHAR,@V_OLD_QTDEVOREQU);
         END;

         IF @V_OLD_IDSTITREQU IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Situacao='     + @V_OLD_IDSTITREQU;
         END;

         IF @V_OLD_CDFILILANC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FilLanc='      + @V_OLD_CDFILILANC;
         END;

         IF @V_OLD_NRLANCESTQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Lancamento='   + @V_OLD_NRLANCESTQ;
         END;

         IF @V_OLD_NRSEQUITEM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrSeqIt='      + @V_OLD_NRSEQUITEM;
         END;

         IF @V_OLD_NRLOTEESTQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Lote='         + @V_OLD_NRLOTEESTQ;
         END;

         IF @V_OLD_NRSUBLOTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SubLote='      + @V_OLD_NRSUBLOTE;
         END;

         IF @V_OLD_DSREQUIAPROV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descricao='    + @V_OLD_DSREQUIAPROV;
         END;

         SET @V_TIPO     = '3';
         SET @V_ITPESQ   = @V_OLD_CDFILIAL+ @V_OLD_NRREQUESTO + @V_OLD_CDPRODUTO;
      END
      ELSE BEGIN
         IF (@V_IDCOMANDO = 'U') BEGIN
            IF (ISNULL(@V_OLD_QTREQUESTO,-1)    <> ISNULL(@V_NEW_QTREQUESTO, -1))   OR
               (ISNULL(@V_OLD_QTDEVOREQU,-1)    <> ISNULL(@V_NEW_QTDEVOREQU, -1))   OR
               (ISNULL(@V_OLD_IDSTITREQU,'#')   <> ISNULL(@V_NEW_IDSTITREQU,'#'))   OR
               (ISNULL(@V_OLD_CDFILILANC,'#')   <> ISNULL(@V_NEW_CDFILILANC,'#'))   OR
               (ISNULL(@V_OLD_NRLANCESTQ,'#')   <> ISNULL(@V_NEW_NRLANCESTQ,'#'))   OR
               (ISNULL(@V_OLD_NRSEQUITEM,'#')   <> ISNULL(@V_NEW_NRSEQUITEM,'#'))   OR
               (ISNULL(@V_OLD_NRLOTEESTQ,'#')   <> ISNULL(@V_NEW_NRLOTEESTQ,'#'))   OR
               (ISNULL(@V_OLD_NRSUBLOTE,'#')    <> ISNULL(@V_NEW_NRSUBLOTE,'#'))    OR
               (ISNULL(@V_OLD_DSREQUIAPROV,'#') <> ISNULL(@V_NEW_DSREQUIAPROV,'#')) BEGIN
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL+@V_OLD_NRREQUESTO+@V_OLD_CDPRODUTO;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDFILIAL+@V_NEW_NRREQUESTO+@V_NEW_CDPRODUTO;
         END;

         IF (ISNULL(@V_OLD_QTREQUESTO,-1)    <> ISNULL(@V_NEW_QTREQUESTO, -1)) BEGIN
            SET @V_DESC = @V_DESC + ' Qtde Req='     + CONVERT(VARCHAR,@V_NEW_QTREQUESTO);
         END;
         IF (ISNULL(@V_OLD_QTDEVOREQU,-1)    <> ISNULL(@V_NEW_QTDEVOREQU, -1)) BEGIN
            SET @V_DESC = @V_DESC + ' Qtde Dev='     + CONVERT(VARCHAR,@V_NEW_QTDEVOREQU);
         END;
         IF (ISNULL(@V_OLD_IDSTITREQU,'#')   <> ISNULL(@V_NEW_IDSTITREQU,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' Situacao='     + @V_NEW_IDSTITREQU;
         END;
         IF (ISNULL(@V_OLD_CDFILILANC,'#')   <> ISNULL(@V_NEW_CDFILILANC,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' FilLanc='      + @V_NEW_CDFILILANC;
         END;
         IF (ISNULL(@V_OLD_NRLANCESTQ,'#')   <> ISNULL(@V_NEW_NRLANCESTQ,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' Lancamento='   + @V_NEW_NRLANCESTQ;
         END;
         IF (ISNULL(@V_OLD_NRSEQUITEM,'#')   <> ISNULL(@V_NEW_NRSEQUITEM,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' NrSeqIt='      + @V_NEW_NRSEQUITEM;
         END;
         IF (ISNULL(@V_OLD_NRLOTEESTQ,'#')   <> ISNULL(@V_NEW_NRLOTEESTQ,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' Lote='         + @V_NEW_NRLOTEESTQ;
         END;
         IF (ISNULL(@V_OLD_NRSUBLOTE,'#')    <> ISNULL(@V_NEW_NRSUBLOTE,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' SubLote='      + @V_NEW_NRSUBLOTE;
         END;
         IF (ISNULL(@V_OLD_DSREQUIAPROV,'#') <> ISNULL(@V_NEW_DSREQUIAPROV,'#')) BEGIN
            SET @V_DESC = @V_DESC + ' Descricao='    + @V_NEW_DSREQUIAPROV;
         END;
      END;
      FETCH NEXT FROM C_CURSOR_ITREQ  INTO @V_IDCOMANDO,
                                      @V_NEW_CDFILIAL,
                                      @V_NEW_NRREQUESTO,
                                      @V_NEW_CDPRODUTO,
                                      @V_NEW_QTREQUESTO,
                                      @V_NEW_QTDEVOREQU,
                                      @V_NEW_IDSTITREQU,
                                      @V_NEW_CDFILILANC,
                                      @V_NEW_NRLANCESTQ,
                                      @V_NEW_NRSEQUITEM,
                                      @V_NEW_NRLOTEESTQ,
                                      @V_NEW_NRSUBLOTE,
                                      @V_NEW_DSREQUIAPROV,
                                      @V_OLD_CDFILIAL,
                                      @V_OLD_NRREQUESTO,
                                      @V_OLD_CDPRODUTO,
                                      @V_OLD_QTREQUESTO,
                                      @V_OLD_QTDEVOREQU ,
                                      @V_OLD_IDSTITREQU,
                                      @V_OLD_CDFILILANC,
                                      @V_OLD_NRLANCESTQ,
                                      @V_OLD_NRSEQUITEM,
                                      @V_OLD_NRLOTEESTQ,
                                      @V_OLD_NRSUBLOTE,
                                      @V_OLD_DSREQUIAPROV;

   END;
   CLOSE C_CURSOR_ITREQ;
   DEALLOCATE C_CURSOR_ITREQ;

   IF @V_TIPO <> '0' BEGIN
      EXEC TEKNISA.NMUSUARIO V_USUARIO;

      EXEC WEBTUNNING @V_DSREMOTEADDR,
                      @V_DSREMOTEHOST,
                      @V_DSSERVERRDM,
                      @V_DSSERVMETHOD,
                      @V_DSREMOTEOPER;

      IF NOT @V_DESC IS NULL BEGIN
         SET @V_DTOPER = GETDATE();
         INSERT INTO LOGOPERA
              (NMTABELA,     DTOPERACAO,   NMRESPOPER, IDTIPOOPER,    DSOPERACAO, CDPESQITEM,
               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
           VALUES
              ('ITREQUESTO', @V_DTOPER, ISNULL(@V_USUARIO,' '), @V_TIPO, ISNULL(@V_DESC, 'VAZIO'),
               @V_ITPESQ, @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD,
               @V_DSREMOTEOPER);
      END;
   END;
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'LOG_EST_ITREQUESTO','5.01.017';
GO


