function Bco24100_ExtratoDeMovimentacaoReal_Controller(ZhFilterPreferences) {
    
    /**
     * Variáveis de Inicialização
     **/
     
    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */

    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.filterRelatorio = function(widget, preference){
        var cdEmpresa = preference.FILTER_ROW.CDEMPRESA;
        var cdReducont = preference.FILTER_ROW.CDREDUCONT;
        var dtMovreal = preference.FILTER_ROW.DTMOVREAL;
        var tcdEmpresa = preference.FILTER_ROW.TCDEMPRESA;
        var tcdReducont = preference.FILTER_ROW.TCDREDUCONT;
         
        if(cdEmpresa === undefined || cdEmpresa.length === 0 || cdEmpresa === null){
            tcdEmpresa = 'T';
        }else{
            tcdEmpresa = '';
        }
        
        if(cdReducont === undefined || cdReducont.length === 0 || cdReducont === null){
            tcdReducont = 'T';
        }else{
            tcdReducont = '';
        }
        
        widget.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA':
                    filtro.value = cdEmpresa?cdEmpresa.join("_"): '';
                break;
                case 'TCDEMPRESA':
                    filtro.value = tcdEmpresa?tcdEmpresa:'';
                break;
                case 'CDREDUCONT':
                    filtro.value = cdReducont?cdReducont.join("_"):'';
                break;
                case 'TCDREDUCONT':
                    filtro.value = tcdReducont?tcdReducont:'';
                break;
                case 'DATAINIC':
                    filtro.value = dtMovreal.start;
                break;
                case 'DATAFINA':
                    filtro.value = dtMovreal.end;
                break;
            }
        });
        delete preference.FILTER_ROW.DTMOVREAL;
        preference.CUSTOM_FILTER_ROW = {};
         
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Bco24100_ExtratoDeMovimentacaoReal_Controller', Bco24100_ExtratoDeMovimentacaoReal_Controller);
});