var Bco57000_OrcamentoFinanceiroCentroCusto_Controller = function(ScreenService, ZHPromise, templateManager, General, ZhFilterPreferences) {

    this.recalcularOrcamentoCentroCusto = function(popup){
        var centcust = templateManager.container.getWidget('financeiro_centro_custo');
        var row = null;
        if (popup.getField('NMFILIAL').isVisible){
            row = {
                'CDEMPRESA': popup.currentRow.CDEMPRESA,
                'CDFILIAL': popup.currentRow.CDFILIAL,
                'DTORCAFINA_INI': popup.currentRow.DTORCAFINA.start,
                'DTORCAFINA_FIN': popup.currentRow.DTORCAFINA.end
            };
        }else{
            row = {
                'CDEMPRESA': popup.currentRow.CDEMPRESA,
                'DTORCAFINA_INI': popup.currentRow.DTORCAFINA.start,
                'DTORCAFINA_FIN': popup.currentRow.DTORCAFINA.end
            };
        }
        if (popup.isValid()){
            var classificacoesMarcadas = centcust.getCheckedRows();
            var dataSet = [];
            dataSet.push(row);
            dataSet.push(classificacoesMarcadas);
            var route = 'fin_movimentacaoBancaria#/recalcularOrcamentoCentroCusto';
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function(response){
                    ScreenService.closePopup(true);
                    centcust.activate();
                    ScreenService.showMessage('Recálculo realizado com sucesso.');
                    centcust.unSelectAll();
                }.bind(this))
                .catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
        }
    };

    this.salvarOrcamento = function(orcamento){
        if (orcamento.getParent().isValid()){
            var rowsAlteradas = orcamento.dataSource.data.filter(function(filtro){
                return filtro.changed;
            });
            var dataSet = [];
            var row = null;
             if (orcamento.getParent().getField('NMFILIAL').isVisible){
                row = {
                    'CDEMPRESA': orcamento.getParent().currentRow.CDEMPRESA,
                    'CDFILIAL': orcamento.getParent().currentRow.CDFILIAL,
                    'CDCENTCUST': orcamento.getParent().getParent().getParent().currentRow.CDCENTCUST,
                    'CDCLASSFINA': orcamento.getParent().getParent().currentRow.CDCLASSFINA,
                    'DTMES': orcamento.getParent().currentRow.DTMES
                };
            }else{
                row = {
                    'CDEMPRESA': orcamento.getParent().currentRow.CDEMPRESA,
                    'CDCENTCUST': orcamento.getParent().getParent().getParent().currentRow.CDCENTCUST,
                    'CDCLASSFINA': orcamento.getParent().getParent().currentRow.CDCLASSFINA,
                    'DTMES': orcamento.getParent().currentRow.DTMES
                };
            }
            dataSet.push(row);
            dataSet.push(rowsAlteradas);
            var route = 'fin_movimentacaoBancaria#/saveOrcamentoCentroCusto';
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function(response){
                    orcamento.reload().then(function(){
                        orcamento.list();
                        ScreenService.showMessage('Orçamento realizado com sucesso.');
                    });

                }.bind(this))
                .catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
        }
    };

    this.cadastramentoAutomaticoOrcamentoCentroCusto = function(popup){
        var orcamento = templateManager.container.getWidget('orcamento_centro_custo');
        var rowOrigem = null;
        var rowDestino = null;
        if (popup.getField('NMFILIALORIGEM').isVisible){
            rowOrigem = {
                'CDEMPRESA': popup.currentRow.CDEMPRESAORIGEM,
                'CDFILIAL': popup.currentRow.CDFILIALORIGEM
            };
            rowDestino = {
                'CDEMPRESA': popup.currentRow.CDEMPRESADESTINO,
                'CDFILIAL': popup.currentRow.CDFILIALDESTINO
            };
        }else{
            rowOrigem = {
                'CDEMPRESA': popup.currentRow.CDEMPRESAORIGEM
            };
            rowDestino = {
                'CDEMPRESA': popup.currentRow.CDEMPRESADESTINO
            };
        }
        var dataSet = [];
        var rowOrcamento = {
            'OPCAOOPERACAO': popup.currentRow.OPCAOOPERACAO,
            'DTMES': popup.currentRow.DTMES
        };

        dataSet.push(rowOrcamento);
        dataSet.push(rowOrigem);
        dataSet.push(rowDestino);

        if (popup.isValid()){
            var route = 'fin_movimentacaoBancaria#/cadastramentoAutomaticoCentCust';
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function(response){
                    ScreenService.closePopup(true);
                    orcamento.getParent().getParent().activate();
                    ScreenService.showMessage('Cadastramento Automático realizado com sucesso.');
                }.bind(this))
                .catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
        }
    };

    this.setParamGeral = function(){
        var route = 'fin#/crud/paramgeral';
        General.callRestEngine(route, 'FilterData', [])
            .then(function(response){
                this.validaVisibilidadeFilialEmpresa(response.dataset.paramgeral[0]);
            }.bind(this))
            .catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
    };

    this.validaVisibilidadeFilialEmpresa = function(paramGeral){
        var recalculo = templateManager.container.getWidget('recalculo');
        var orcamento = templateManager.container.getWidget('tabbed_orcamento_centro_custo');
        var cadastramentoAutomatico = templateManager.container.getWidget('cadastramentoAutomatico');
        
        if (paramGeral.IDTPORCAFINA == 'E'){
            this.setFieldsParametricacaoEmpresa(recalculo, orcamento, cadastramentoAutomatico);
        }else{
            recalculo.getField('NMFILIAL').isVisible = true;
            recalculo.getField('DTORCAFINA').class = '12';
            orcamento.getField('NMFILIAL').isVisible = true;
            orcamento.getField('NMEMPRESA').class = '5';
            orcamento.getField('DTMES').class = '2';
            cadastramentoAutomatico.getField('NMEMPRESAORIGEM').class = '6';
            cadastramentoAutomatico.getField('NMEMPRESADESTINO').class = '6';
            cadastramentoAutomatico.getField('NMFILIALORIGEM').isVisible = true;
            cadastramentoAutomatico.getField('CDFILIALDESTINO').isVisible = true;
        }
    };

    this.setFieldsParametricacaoEmpresa = function(recalculo, orcamento, cadastramentoAutomatico){
        recalculo.getField('NMFILIAL').isVisible = false;
        recalculo.getField('DTORCAFINA').class   = '6';
        orcamento.getField('NMFILIAL').isVisible = false;
        orcamento.getField('NMEMPRESA').class    = '8';
        orcamento.getField('DTMES').class        = '4';
        cadastramentoAutomatico.getField('NMEMPRESAORIGEM').class     = '12';
        cadastramentoAutomatico.getField('NMEMPRESADESTINO').class    = '12';
        cadastramentoAutomatico.getField('NMFILIALORIGEM').isVisible  = false;
        cadastramentoAutomatico.getField('CDFILIALDESTINO').isVisible = false;
    };

    this.openPopupRecalculoOrcamento = function(){
        var recalculo = templateManager.container.getWidget('recalculo');
        ScreenService.openPopup(recalculo).then(function(){
            recalculo.isVisible = true;
            if (!recalculo.getField('NMEMPRESA').value()){
                this.buscaPadraoEmpresa(recalculo);
            }
        }.bind(this));
    };

    this.cancelarRecalculo = function(recalculo){
        ScreenService.closePopup();
        recalculo.isVisible = false;
    };

    this.openPopupCadastramentoAutomatico = function(){
        var cadastramentoAutomatico = templateManager.container.getWidget('cadastramentoAutomatico');
        ScreenService.openPopup(cadastramentoAutomatico).then(function(){
            cadastramentoAutomatico.isVisible = true;
            cadastramentoAutomatico.getField('OPCAOOPERACAO').setValue("I");
            if (!cadastramentoAutomatico.getField('NMEMPRESAORIGEM').value()){
                this.buscaPadraoEmpresa(cadastramentoAutomatico);
            }
        }.bind(this));
    };

    this.cancelarCadastramentoAutomatica = function(cadastramentoAutomatico){
        ScreenService.closePopup();
        cadastramentoAutomatico.isVisible = false;
    };

    this.openSwipeOrcamentoCentroCusto = function(centroDeCustos){
        var orcamentoFinanceiro = templateManager.container.getWidget('orcamento_centro_custo');
        ScreenService.openSwipe(orcamentoFinanceiro.getParent()).then(function(){
            if (!orcamentoFinanceiro.getParent().getField('CDEMPRESA').value()){
                this.buscaPadraoEmpresa(orcamentoFinanceiro.getParent()).then(function(){
                    this.redefineGridOrcamento(orcamentoFinanceiro);
                }.bind(this));
            }else{
                if (orcamentoFinanceiro.getParent().getField('CDFILIAL').value() &&
                    orcamentoFinanceiro.getParent().getField('DTMES').value()){

                    this.redefineGridOrcamento(orcamentoFinanceiro);
                }else{
                    orcamentoFinanceiro.dataSource.data = [];
                }
            }
        }.bind(this));
    };

    this.redefineGridOrcamento = function(orcamentoFinanceiro){
        if (orcamentoFinanceiro.getParent().getField('DTMES').value() &&
            orcamentoFinanceiro.getParent().getField('CDFILIAL').value() &&
            orcamentoFinanceiro.getParent().getField('CDEMPRESA').value()){
            this.setFiltroOrcamentoCentroCusto(orcamentoFinanceiro).then(function(){
                this.carregaGridOrcamento(orcamentoFinanceiro);
            }.bind(this));
        }else{
            orcamentoFinanceiro.dataSource.data = [];
        }
    };

    this.carregaGridOrcamento = function(orcamentoFinanceiro){
        if (orcamentoFinanceiro.getParent().isValid()){
            orcamentoFinanceiro.reload();
        }
    };

    this.voltar = function(){
        var financeiro_centro_custo = templateManager.container.getWidget('financeiro_centro_custo');
        ScreenService.goBack().then(function(){
            financeiro_centro_custo.activate();
        });
    };

    this.setFiltroFilial = function(widget, empresa, filial){
        var valorEmpresa = widget.getField(empresa).value();
        
        if (valorEmpresa){
            widget.getField(filial).readOnly = false;
            widget.getField(filial).setValue('');
            widget.getField(filial).dataSourceFilter[0].value = valorEmpresa;
        }else{
            widget.getField(filial).readOnly = true;
            widget.getField(filial).setValue('');
            widget.getField(filial).dataSourceFilter[0].value = '';
        }
        
        if (widget.name == 'tabbed_orcamento_centro_custo')
            templateManager.container.getWidget('orcamento_centro_custo').dataSource.data = [];
        
        widget.getField(filial).reload();
    };

    this.setFiltroOrcamentoCentroCusto = function(orcamentoFinanceiro){
        var deferred = ZHPromise.defer();
        var dtmes = orcamentoFinanceiro.getParent().currentRow.DTMES;
        orcamentoFinanceiro.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = orcamentoFinanceiro.getParent().currentRow.CDEMPRESA;
                    break;
                case 'CDFILIAL': filter.value = orcamentoFinanceiro.getParent().currentRow.CDFILIAL;
                    break;
                case 'CDCENTCUST': filter.value = orcamentoFinanceiro.getParent().getParent().getParent().currentRow.CDCENTCUST;
                    break;
                case 'CDCLASSFINA': filter.value = orcamentoFinanceiro.getParent().getParent().currentRow.CDCLASSFINA;
                    break;
                case 'ANOINI': filter.value = '01/01/' + dtmes;
                    break;
                case 'ANOFIM': filter.value = '31/12/' + dtmes;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filtroFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filtroFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;
            var routeEmpresa = 'fin#/crud/empresa';
            var filtroEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": cdempresa}];
            General.callRestEngine(routeEmpresa, 'FilterData', filtroEmpresa).then(function (response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                var cdempresa = empresa.CDEMPRESA;
                var nmempresa = empresa.NMEMPRESA;
                if (widget.name == 'cadastramentoAutomatico'){
                    widget.getField('CDFILIALORIGEM').setValue(filial.CDFILIAL);
                    widget.getField('NMFILIALORIGEM').setValue(filial.NMFILIAL);
                    widget.getField('NMFILIALORIGEM').dataSourceFilter[0].value = cdempresa;
                    widget.getField('CDFILIALORIGEM').readOnly = false;
                    widget.getField('NMFILIALORIGEM').readOnly = false;
                    widget.getField('CDEMPRESAORIGEM').setValue(cdempresa);
                    widget.getField('NMEMPRESAORIGEM').setValue(nmempresa);
                }else{
                    widget.getField('CDFILIAL').setValue(filial.CDFILIAL);
                    widget.getField('NMFILIAL').setValue(filial.NMFILIAL);
                    widget.getField('NMFILIAL').dataSourceFilter[0].value = cdempresa;
                    widget.getField('CDFILIAL').readOnly = false;
                    widget.getField('NMFILIAL').readOnly = false;
                    widget.getField('CDEMPRESA').setValue(cdempresa);
                    widget.getField('NMEMPRESA').setValue(nmempresa);
                }
                if (widget.name == 'recalculo'){
                    if (!widget.getField('DTORCAFINA').value()){
                        var start = moment().format('DD/MM/YYYY');
                        var end   = moment().format('DD/MM/YYYY');
                        widget.getField('DTORCAFINA').setValue({start : start, end : end});
                    }
                }else{
                    if (!widget.getField('DTMES').value()){
                        widget.getField('DTMES').setValue(parseInt(moment().format('YYYY')));
                    }
                }
                deferred.resolve();
            }.bind(this));
        }.bind(this));
        return deferred.promise;
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Bco57000_OrcamentoFinanceiroCentroCusto_Controller', Bco57000_OrcamentoFinanceiroCentroCusto_Controller);
});