package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class TipoDeDespesasPage extends PageBase {
    //Mapear tela

    //Ações da Tela
    By aplicarFiltroDespesa = By.xpath("//span[text()= 'Aplicar filtro']");
    By fecharFiltroDespesa = By.xpath("//span[text()= 'Fechar']");
    By limparFiltroDespesa = By.xpath("//*[@data-zh-title-tooltip='Limpar Filtro']");
    By adicionarDespesa = By.xpath("//*[@data-zh-title-tooltip='Adicionar (F2)']");
    By salvarDespesa = By.xpath("//span[text()= 'Salvar Despesa']");
    By cancelarDespesa = By.xpath("//span[text()= 'Cancelar']");
    By editarDespesa = By.xpath("//*[@data-zh-title-tooltip='Editar (F3)']");
    By excluirDespesa = By.xpath("//*[@data-zh-title-tooltip='Excluir (Ctrl + D)']");
    By confirmaExclusaoDespesa = By.xpath("//*[@data-zh-focus-field='true']");
    By voltarDespesa = By.xpath("//span[text()= 'Voltar']");

    //Opções ...
    By reticenciasDespesas = By.id("down");
    By pesquisarDespesas = By.id("search");
    By filtroDespesas = By.id("filter");

    //Filtro Principal
    By filtroTipoDespesa = By.id("NMDESPESA");
    By filtroHistoricoPadraoDespesa = By.id("DSHISTPADR");
    By filtroContaContabilDespesa = By.id("NMCONTCTBL");
    By filtroContabilizaDepesa = By.id("IDCTBLDESP");

    //Campos Tela
    By tipoDespesa = By.id("NMDESPESA");
    By historicoPadraoDespesaAux = By.id("DSHISTPADR");
    By historicoPadraoDespesa = By.xpath("//*[@id='DSHISTPADR']//input");
    By historicoPadraoPesquisa = By.xpath("//*[@id='DSHISTPADR']//*[@zh-icon='no-border search']");
    By historicoPadraoSelecionar = By.xpath("//span[text()= '0001']");
    By historicoPadraoProcurar = By.xpath("//*[@class='mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By contaContabilDespesaAux = By.id("NMCONTCTBL");
    By contaContabilDespesa = By.xpath("//*[@id='NMCONTCTBL']//input");
    By contaContabilPesquisa = By.xpath("//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By contaContabilSelecionar = By.xpath("//span[text()= '19']");
    By contaContabilProcurar = By.xpath("//*[@class='mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By contabilizaDespesa = By.xpath("//*[@class='current']");
    By contabilizaSimDespesa = By.xpath("//*[@class='list zh-new-select-list']//*[@class='option ']");
    By contabilizaNaoDespesa = By.xpath("//*[@class='list zh-new-select-list']//*[@class='option selected focus']");

    //Clicar para alterar/excluir
    By clicarCadastroDespesa = By.xpath("//span[text()= 'Despesa Automatizada']");

    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    public void clicarAdicionarDespesa(){
        waitForVisibilityOfElementLocated(loadingWait);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarDespesa);
    }

    public void preencherTipoDespesa(String TipoDespesa){
        click(tipoDespesa);
        sendKeys(tipoDespesa,TipoDespesa);
    }

    public void clicarPesquisaHistoricoPadrao(){
        click(historicoPadraoDespesa);
        click(historicoPadraoPesquisa);
    }

    public void preencherHistoricoPadrao (String HistoricoPadrao){
        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(historicoPadraoProcurar);
        sendKeys(historicoPadraoProcurar,HistoricoPadrao);
    }

    public void selecionarHistoricoPadrao (){
        click(historicoPadraoSelecionar);
    }

    public void clicarPesquisaContaContabil(){
        click(contaContabilDespesa);
        click(contaContabilPesquisa);
    }

    public void preencherContaContabil (String ContaContabil){
        sendKeys(contaContabilProcurar,ContaContabil);
    }

    public void selecionarContaContabil () {
        click(contaContabilSelecionar);
    }

    public void preencherContabiliza(){
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(contabilizaDespesa);
        click(contabilizaSimDespesa);
    }

    public void preencerSimContabiliza(){
        click(contabilizaSimDespesa);
    }

    public void preencerNaoContabiliza(){
        click(contabilizaNaoDespesa);
    }

    public void salvarDespesa(){
        click(salvarDespesa);
    }

    public void clicarDespesaCadastrada (){
        waitForVisibilityOfElementLocated(loadingWait);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicarCadastroDespesa);
    }

    public void clicarEditarDespesa (String TipoDespesa2){
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(editarDespesa);
        click(tipoDespesa);
        sendKeys(tipoDespesa,TipoDespesa2);
        click(contabilizaDespesa);
        click(contabilizaSimDespesa);
    }

    public void clicarExcluirDespesa(){
        waitForVisibilityOfElementLocated(loadingWait);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(excluirDespesa);
        click(confirmaExclusaoDespesa);
    }

    public void clicarAplicarFiltro (){
        click(aplicarFiltroDespesa);
    }
}
