package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class ApuracaoImpostoICMSSTPage extends PageBase {
    // Fitro
    By mensagemApuraImp = By.xpath("//*[.='OK']");
    By filtroApuracao = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By filtroApuracaoMunicipal = By.xpath("//*[@data-value='2']");
    By filtroEmpresa = By.xpath("//span[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");
    By filtroEmpresaHela = By.xpath("//div[@data-ng-repeat=\"rowIndex in filtered = controller.getVisibleRowCount()\"]");
    By filtroImposto = By.xpath("//*[@id=\"DSIMPOSTONFE\"]//*[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");
    By filtroImpostoICMSST = By.xpath("//span[text() = '80']");
    By filtroInscricaoMun = By.xpath("//*[@id=\"CDINSCMUNI\"]//*[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");
    By filtroInscricaoMunAux = By.xpath("//span[text() = '35800712']");


    By filtroAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro'][1]");

    By adicionarMapa = By.xpath("//a[@data-zh-title-tooltip = 'Adicionar (F2)']");

    By nomeMapa = By.id("NMMAPAAPUR");

    By salvarMapaapurac = By.xpath("//div[@id='footer']//span[text() = 'Salvar']");

    By selecionarmapaapurac = By.xpath("//span[text() = 'Apuração de ICMS-ST']");

    By acoes = By.xpath("//span[@data-zh-bind-translate=\"'Actions'\"]");

    By apurar = By.xpath("//span[text() = 'Apurar']");

    By MensagemOk = By.xpath("//span[@data-ng-bind=\"button.label\"]");

    By cancelar = By.xpath("//span[@class=\"zh-footer-title-sprit ng-binding\"]");

    By excluir = By.xpath("//*[@data-zh-title-tooltip=\"Excluir (Ctrl + D)\"]");

    By sim = By.xpath("//span[text() = 'Sim']");

    By AbaArrecadacaoFiscal = By.xpath("//*[text() = 'Arrecadação Fiscal']");

    By AbaGuiaComplementar = By.xpath("//*[text() = 'Guias Complementares']");

    By AbaInformacoesAdicionais = By.xpath("//*[text() = 'Informações Adicionais']");

    By Editar = By.xpath("//div[@class=\"zh-test-box\"]");

    By VencimentoArrecadacaoFis = By.id("DTVENCGUIA");

    By CodDaReceita = By.xpath("//*[@zh-id=\"63224560727895264981219\"]");

    By VrDeJuros = By.xpath("//*[@zh-id=\"63224560714647521881234\"]");

    By Salvar = By.xpath("//span[text() = 'Salvar']");

    By Voltar = By.xpath("//span[text() = 'Voltar']");

    By Adicionar = By.xpath("//div[@class=\"zh-test-box\"]");

    By CodigoObrigacao = By.id("CDOBRIGAGUIA");

    By CodigoDaReceita = By.xpath("//span[@class=\"zh-icon zh-icon-search zh-icon-no-border\"]");

    By CodReceita = By.xpath("//span[text() = '046-2']");

    By VrBaseDeCalculo = By.id("VRBASEGUIACOMP");

    By VrReceita = By.id("VRRECEITAGUIA");

    By VencimentoGuiaCompl = By.id("DTVENCGUIACOMPL");

    By DescricaoGuiaCompl = By.id("DESCGUIACOMPL");

    By NumDoProcesso = By.id("NRPROCESSOGUIA");

    By CodInformacao = By.id("CDINFADICMAPA");

    By DescInformacao = By.id("DSINFADICMAPA");

    By ValorInfoAdicional = By.id("VRINFADICMAPA");

    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    public void clicarOkMsgApuraImp(){
        click(mensagemApuraImp);
    }

    public void clicarEmTipodeapuracao(){
        click(filtroApuracao); click(filtroApuracaoMunicipal);
    }

    public void clicarEmEmpresa(){
        click(filtroEmpresa); click(filtroEmpresaHela);
    }

    public void clicarEmImposto(){
        click(filtroImposto); click(filtroImpostoICMSST);
    }

    public void clicarEmInscricaoMunicipal(){
        click(filtroInscricaoMun); click(filtroInscricaoMunAux);
    }

    public void clicarAplicarFiltro(){
        click(filtroAplicarFiltro);
    }

    public void clicarAdicionarMapa() {
        waitForVisibilityOfElementLocated(loadingWait);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarMapa);
    }

    public void preencherNomedomapa(String nomedomapa){
        click(nomeMapa); sendKeys(nomeMapa, nomedomapa);
    }


    public void clicarsalvarMapa(){
        click(salvarMapaapurac);
    }

    public void clicarEmMapaApuracao(){
        click(selecionarmapaapurac);
    }

    public void clicarEmAcoes(){
        click(acoes);
    }

    public void clicarEmApurar(){
        click(apurar);
    }

    public void clicarOk(){
        click(MensagemOk);
    }


    public void clicarEmCancelar(){
        click(cancelar);
    }

    public void clicarEmExcluir(){
        click(excluir);
    }

    public void clicarEmSim(){
        click(sim);
    }

    public void clicarNaAbaArrecadacaoFiscal(){
        click(AbaArrecadacaoFiscal);
    }

    public void clicarNaAbaGuiaComplementar(){
        click(AbaGuiaComplementar);
    }

    public void clicarEmEditar(){
        click(Editar);
    }

    public void preencherVencimentoArrecadacaoFis(String VencimentoArrecFiscal){
        click(VencimentoArrecadacaoFis); sendKeys(VencimentoArrecadacaoFis, VencimentoArrecFiscal);
    }

    public void preencherCodDaReceita(String CodigoDaReceita){
        click(CodDaReceita); sendKeys(CodDaReceita, CodigoDaReceita);
    }

    public void preencherVrDeJuros(String ValorDeJuros){
        click(VrDeJuros); sendKeys(VrDeJuros, ValorDeJuros);
    }

    public void clicarEmSalvar(){
        click(Salvar);
    }

    public void clicarEmVoltar(){
        click(Voltar);
    }

    public void clicarEmAdicionar(){
        click(Adicionar);
    }

    public void preencherCodigoObrigacao(String CodObrigacao){
        click(CodigoObrigacao); sendKeys(CodigoObrigacao, CodObrigacao);
    }

    public void clicarEmCodigoDaReceita(){
        click(CodigoDaReceita); click(CodReceita);
    }

    public void preencherVrBaseDeCalculo(String ValorBaseCalculo){
        click(VrBaseDeCalculo); sendKeys(VrBaseDeCalculo, ValorBaseCalculo);
    }

    public void preencherVrReceita(String ValorDaReceita){
        click(VrReceita); sendKeys(VrReceita, ValorDaReceita);
    }

    public void preencherVencimentoGuiaCompl(String VencGuiaCompl){
        click(VencimentoGuiaCompl); sendKeys(VencimentoGuiaCompl, VencGuiaCompl);
    }

    public void preencherDescricaoGuiaCompl(String DescricaoGuiaComp){
        click(DescricaoGuiaCompl); sendKeys(DescricaoGuiaCompl, DescricaoGuiaComp);
    }

    public void preencherNumDoProcesso(String NumProcesso){
        click(NumDoProcesso); sendKeys(NumDoProcesso, NumProcesso);
    }

    public void clicarNaAbaInformacoesAdicionais(){
        click(AbaInformacoesAdicionais);

    }

    public void preencherCodInformacao(String CodigoInfo){
        click(CodInformacao); sendKeys(CodInformacao, CodigoInfo);
    }

    public void preencherDescInformacao(String DescricaoInformacao){
        click(DescInformacao); sendKeys(DescInformacao, DescricaoInformacao);
    }

    public void preencherValorInfoAdicional(String ValorInfAdic){
        click(ValorInfoAdicional); sendKeys(ValorInfoAdicional, ValorInfAdic);
    }
}