package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.chrome.ChromeDriver;
import org.testng.Assert;

import java.sql.Driver;
import java.util.concurrent.TimeUnit;



public class ParametrosDeControleBancarioPage extends PageBase {


    By Financeiro = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/section/header/div/div/ul/li[1]/label/a");
    By MENU = By.xpath("//div[@class='bars']");
    By PARAMETRIZACAO = By.xpath("//span[contains(text(),'Parametrização')]");
    By FINANCEIRO = By.xpath("//li[@class='menu-item closed sub-menu-item has-child visible']//span[@class='menu-title ng-binding has-submenu'][normalize-space()='Financeiro']");

    By BotaoProcurar = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");

    By ParametrosDeControleBancario =  By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li/span/span[2]");

    By ClicarAdcionar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li/a/div");
    By Salvar = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    By BotaoEditar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li/a/div");

    //Contabilização
    By TransferenciaEmContaCorrente = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[1]/div/div/div/div/div[2]");
    By TransferenciaEmContaCorrenteOpcaoSim = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[1]/div/div/div/div/div[2]/ul/li[1]");

    //Fechamento do Dia

    By ControlaDataDePocessamento = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div/div/div/div[2]");
    By OpcaoSimControlaDataDePocessamento = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[2]/div/div/div/div/div[2]/ul/li[1]");

    // Acesso Conta Corrente
    By PermiteTransferenciaParaTodasContasCorrentes  = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[3]/div/div/div/div/div[2]");
    By OpcaoSimPermiteTransferenciaParaTodasContasCorrentes  = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[3]/div/div/div/div/div[2]/ul/li[1]");

    //Intervalo de Datas no filtro de Lançamento entre Contas Corrente
     By QuantidadeDeDiasAnterioresADataDeProcessamento = By.cssSelector("#QTDIAANTLANC");
     By QuantidadeDeDiasPosterioresADataDeProcessamento = By.cssSelector("#QTDIAAPOLANC");

     //Classificação Financeira para Transferências Bancárias
     By ClassificacaoFinanceira = By.cssSelector("#DSCLASSFINA");
     By OpcaoClassificacaoFinanceira = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[6]/div/div/div/div/div[3]/span[1]");

     //Intervalo de Datas no filtro de Transferência entre Contas
     By QuantidadeDeDiasAnterioresADataDeProcessamento2 = By.cssSelector("#QTDIAANTTRAN");
     By QuantidadeDeDiasPosterioresADataDeProcessamento2 = By.cssSelector("#QTDIAAPOTRAN");


     // Configurar Impressora de Cheque
     By TipoDeImpressoraUtilizada = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[7]/div/div[1]/div/div/div[2]");
     By OpcaoTipoDeImpressoraUtilizada = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[7]/div/div[1]/div/div/div[2]/ul/li[2]");

     //Configurar Impressora de Cheque

     By PortaUtilizadaParaImpressao = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[7]/div/div[2]/div/div/div[2]");
     By OpcaoPortaUtilizadaParaImpressao = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section[7]/div/div[2]/div/div/div[2]/ul/li[2]");

    public void ParametrosDeControleBancario(String Procurar) {
        waitForElement(Financeiro);
        waitForElement(MENU);
        click(MENU);
        click(BotaoProcurar);
        clear(BotaoProcurar);
        sendKeys(BotaoProcurar, Procurar);
        click(ParametrosDeControleBancario);

    }

    public void TelaParametrosDeControleBancario(String QuantidadeAnterior, String QuantidadePosterior ) {

        waitForElement(ClicarAdcionar);
        click(BotaoEditar);

        click(TransferenciaEmContaCorrente);
        click(TransferenciaEmContaCorrenteOpcaoSim);

        click(ControlaDataDePocessamento);
        click(OpcaoSimControlaDataDePocessamento);

        click(PermiteTransferenciaParaTodasContasCorrentes);
        click(OpcaoSimPermiteTransferenciaParaTodasContasCorrentes);

        click(QuantidadeDeDiasAnterioresADataDeProcessamento);
        clear(QuantidadeDeDiasAnterioresADataDeProcessamento);
        sendKeys(QuantidadeDeDiasAnterioresADataDeProcessamento, QuantidadeAnterior);

        click(QuantidadeDeDiasPosterioresADataDeProcessamento);
        clear(QuantidadeDeDiasPosterioresADataDeProcessamento);
        sendKeys(QuantidadeDeDiasPosterioresADataDeProcessamento, QuantidadePosterior);

        click(QuantidadeDeDiasAnterioresADataDeProcessamento2);
        clear(QuantidadeDeDiasAnterioresADataDeProcessamento2);
        sendKeys(QuantidadeDeDiasAnterioresADataDeProcessamento2, QuantidadeAnterior);

        click(QuantidadeDeDiasPosterioresADataDeProcessamento2);
        clear(QuantidadeDeDiasPosterioresADataDeProcessamento2);
        sendKeys(QuantidadeDeDiasPosterioresADataDeProcessamento2, QuantidadePosterior);

        click(ClassificacaoFinanceira);
        click(OpcaoClassificacaoFinanceira);

        click(TipoDeImpressoraUtilizada);
        click(OpcaoTipoDeImpressoraUtilizada);
        click(PortaUtilizadaParaImpressao);
        click(OpcaoPortaUtilizadaParaImpressao);

        click(Salvar);



    }



    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
    }

}






